# 重ね合わせ前の各画像に対して #
# SExtractor検出=>星と思われるものだけのFWHM('')をピックアッップ=>iraf/rtextでfits化=>imstatで平均値を見る#
#出力は画像毎のFWHM(mean,mode,stddev,min,max)が格納されたファイル。また各画像で使った星ファイルも残す #

string *objlist
string objlis,conf_sex,output,obj
real   aperture,pscale,minarea,threshold,zero,seeing_sex,strra_min,strra_max,strdec_min,strdec_max,strflag_max,strclass_min,strellip_max
real c1,c2,c3,c4,c5,c6
int num_str,ID,strnum_max

########書き換えるのはココだけ########################################################################
objlis = "finM51.lis"  #天体画像リスト、用意しとく#
output = "finM51_PSF.data"  #最終的に欲しいskyの平均カウントとそこからの標準偏差σ_skyの入るファイル名#

#(1)SExtractorのパラメータ設定#
conf_sex = "detect.sex"      #出力ファイルやparamファイル,Apertureがどうであれあとで全部指定されるのでココに入るパラメータファイルはなんでもいい#
aperture=10  #apertureの設定#
pscale=1.38 #1pixelを見込む角度(arcsec)#
minarea=10 #DETECT_MINAREA#
threshold=5 #DETECT_THRESHOLD#
zero=25.2 #画像のゼロ点(１秒あたりでなく積分時間あたり) 今は適当#
seeing_sex=10  #[arcsec]最初にFWHMの見当値を入力しとく(大体でいい)
strra_min=100   #各画像から星を選び出す時の位置しばり. X座標.Image座標#
strra_max=2900   
strdec_min=100  #y座標#
strdec_max=2900

#(2)星しばりの設定:屋上望遠鏡の場合はゆるめにした方が良さげ#
strflag_max=1  #星として使う天体のフラグ許容範囲:この値より小さい(!<!)#
strclass_min=0.8  #sextractorでのclass starの許容最小値#
strellip_max=0.2  #elliptocotyの許容最大値#
strnum_max=100   #使う星の数の上限#
#########書き換えるのココまで#########################################################################

objlist=objlis

#出力parameterリストest_seeing.paramの作成#
delete ("est_seeing.param",ver-, >& "dev$null")
print ("NUMBER", >> "est_seeing.param")
print ("MAG_APER(1)", >> "est_seeing.param")
print ("MAG_AUTO", >> "est_seeing.param")  
print ("KRON_RADIUS", >> "est_seeing.param")  
print ("BACKGROUND", >> "est_seeing.param")  
print ("X_IMAGE", >> "est_seeing.param")  
print ("Y_IMAGE", >> "est_seeing.param")  
print ("ELLIPTICITY", >> "est_seeing.param")  
print ("FWHM_IMAGE", >> "est_seeing.param")  
print ("FLAGS", >> "est_seeing.param")  
print ("CLASS_STAR", >> "est_seeing.param")  


printf ("# No name  used_str_num  mean  midpt  mode  stddev  min  max\n", > output)


ID=0
while (fscan (objlist, obj) != EOF) #インプットリストの上から１flame毎ループさせる。今考えてる？番目のfitsファイルをobjとして認識#
  {
   ID=ID+1
   #SExtractorをかけるshスクリプトest_see_sex.shの作成#
   delete ("est_see_sex.sh",ver-, >& "dev$null")
   print ("#!/bin/sh", > "est_see_sex.sh")
   print ("sex "//obj//" -CATALOG_NAME test.cat -PARAMETERS_NAME est_seeing.param -DETECT_MINAREA "//minarea//" -DETECT_THRESH "//threshold//" -PHOT_APERTURES "//aperture//" -MAG_ZEROPOINT "//zero//" -PIXEL_SCALE "//pscale//" -SEEING_FWHM "//seeing_sex//" -CHECKIMAGE_TYPE NONE -VERBOSE_TYPE quiet -c "//conf_sex, >> "est_see_sex.sh")  #上で何をコンフィグレーションファイルにしようと、ここでparamとcatが指定される#
   print ("awk '$10<"//strflag_max//" && $11>"//strclass_min//" && $6>"//strra_min//" && $6<"//strra_max//" && $7>"//strdec_min//" && $7<"//strdec_max//" && $8<"//strellip_max//"{print }' test.cat | sort -n -k 2 | head -"//strnum_max//" > str_"//ID//".cat", >> "est_see_sex.sh")  #SExtractor結果のうち星だけをstr_・・.catというリストに書き込んでいく#
   print ("mv test.cat allobj_"//ID//".cat", >> "est_see_sex.sh")  #全天体データも残しとく#
   print ("awk '{print "//pscale//"*$9}' str_"//ID//".cat > tmp_str_fwhm.data", >> "est_see_sex.sh")  #星のFWHMだけデータ化#
   
  #SExtractor実行#
  sh est_see_sex.sh
  wc tmp_str_fwhm.data | scan (num_str)  #fwhm測定に使う星の数#
  printf ("%d-%s :  used star number = %d\n",ID,obj,num_str)

  #FWHMデータのfits変換、imstat#
  delete ("tmp_str_fwhm.fits",ver-, >& "dev$null")
  rtextimage("tmp_str_fwhm.data","tmp_str_fwhm.fits",oty="real",header-,pix+,nsk=0,dim=num_str)
  imstat ("tmp_str_fwhm.fits",fields="mean,midpt,mode,stddev,min,max",upp=INDEF,low=INDEF,ncl=0,usig=3,lsig=3,for-) | scan (c1,c2,c3,c4,c5,c6)

  #output#
  printf ("%d %s %d %7.6f %7.6f %7.6f %7.6f %7.6f %7.6f\n",ID,obj,num_str,c1,c2,c3,c4,c5,c6, >> output)  
   }


#いらないものの消去#
!rm est_seeing.param
!rm est_see_sex.sh
!rm tmp_str_fwhm.data
!rm tmp_str_fwhm.fits