#バックグラウンドのノイズゆらぎを測定するスクリプト。「仮想sky画像に対して測光」をランダムに行う。"sex　天体画像　ランダムシフトさせた仮想sky　-c　~.sex"を多数回行い一回毎に得られるskyの情報(mean.stddev)を多数回平均#
#出力はバックグラウンドゆらぎが格納されたファイル。中身は「aperture(pixel),aperture(arcsec),skyのstddev,skyのmean」なので３列目が1σ相当。#

string *list1
string imobj,imnoise,fsext,output,check_head
real   aperture,pscale,minarea,threshold,c1,c2,c3,zero,limit_mag
real min_hist,max_hist,bin_hist,plot_height
int    nu,mu,n,m,nit,sigma
int    npix1,npix2,xn,yn,xc1,yc1,d1,d2

########書き換えるのはココだけ########################################################################
imobj = "finM51V60s.fits"  #天体画像#
imnoise = "NEOnoise_finM51V60s.fits"  #仮想sky画像#
fsext = "default.sex"      #出力ファイルやparamファイル,Apertureがどうであれあとで全部指定されるのでココに入るパラメータファイルはなんでもいい#
output = "bkgnoise_finM51V60s.txt"  #最終的に欲しいskyの平均カウントとそこからの標準偏差σ_skyの入るファイル名#
check_head = "checkbkg_finM51V60s"  # ***.txt => 全ランダムアパーチャにおける測光値ファイル,  ***.hist => 全測光値を明るさ別にヒストグラムにしたファイル  ***.eps => チェック用の図
sigma=5  #何σ限界を求めたいか?#
zero=25.2 #画像のゼロ点(１秒あたりでなく積分時間あたり)#

#SExtractorのパラメータ設定#
aperture=20  #apertureの設定#
pscale=1.38 #1pixelを見込む角度(arcsec)#
minarea=10 #DETECT_MINAREA#
threshold=5 #DETECT_THRESHOLD#
nit = 10000  #合計何点skyのデータをとるか？#
#########書き換えるのココまで#########################################################################


hselect (imobj,"NAXIS1,NAXIS2",exp+) | scan (npix1,npix2)  #imobjのフォーマット[?:?]がnpix1とnpix2にscanされる#
xn = int(npix1)
yn = int(npix2)

c3 = aperture*pscale  #apertureの角度スケール#

   #出力parameterリストestbackerr.paramの作成#
delete ("estbackerr.param",ver-, >& "dev$null")
print ("X_IMAGE", >> "estbackerr.param")
print ("Y_IMAGE", >> "estbackerr.param")
print ("FLUX_APER(1)", >> "estbackerr.param")  

#SExtractorをかけるshスクリプトestbacknoise.shの作成#
delete ("estbacknoise.sh",ver-, >& "dev$null")
print ("#!/bin/sh", > "estbacknoise.sh")
print ("sex "//imobj//" randomshift.fits -CATALOG_NAME test_bkgerr.cat -DETECT_MINAREA "//minarea//" -DETECT_THRESH "//threshold//" -PHOT_APERTURES "//aperture//" -PARAMETERS_NAME estbackerr.param -MAG_ZEROPOINT "//zero//" -PIXEL_SCALE "//pscale//" -CHECKIMAGE_TYPE NONE -VERBOSE_TYPE quiet -c "//fsext, >> "estbacknoise.sh")  #上で何をパラメータファイルにしようと、ここでestbackerr.paramとtest_bkgerr.catが指定される#
print ("awk '$1!=""#""{print $3}' test_bkgerr.cat >> dataphot1", >> "estbacknoise.sh")  #SExtractor結果のうちFLUX_APER(1)をdataphoto1というリストに書き込んでいく#
print ("awk '$1!=""#""{print -2.5*log($3)/log(10)+"//zero//"}' test_bkgerr.cat >> dataphot2", >> "estbacknoise.sh")  # magnitudes
print ("awk '$1!=""#""{printf ""%e\\n"",$3*10^(-0.4*("//zero//"+48.6))}' test_bkgerr.cat >> dataphot3", >> "estbacknoise.sh")  # fluxes
print ("awk '$1!=""#""{printf ""%f  %f  %e\\n"",$3,-2.5*log($3)/log(10)+"//zero//",$3*10^(-0.4*("//zero//"+48.6))}' test_bkgerr.cat >> "//check_head//".txt", >> "estbacknoise.sh")  # paste to resultant file


#途中経過の表示#
printf ("measure sky fluctuation on %s at %5.3f arcsec diameter\n",imnoise,c3)
printf ("total %d random apertures are used\n",nit)

#ランダムシフトさせた仮想sky画像=randomshift.fitsの作成+estbacknoise.shの実行#
nu=0  #nuは画像に対してestbacknoise.shをかける回数#
mu=0  #muは検出されたskyデータの数=nu*(1枚の画像から得られるデータ数)#
delete ("dataphot1",ver-, >& "dev$null")
delete ("dataphot2",ver-, >& "dev$null")
delete ("dataphot3",ver-, >& "dev$null")
printf ("# ADU  mag  flux\n", > check_head//".txt")
while (mu < nit) #mu<nitの間ループ#
  { 
   nu=nu+1
     #randomshift.fitsの作成#
   urand (1,2,see=INDEF,sca=1) | scan (c1,c2)
   d1 = int(npix1*(0.15+0.7*c1))
   d2 = int(npix2*(0.15+0.7*c2))
   imdelete ("randomshift.fits",ver-, >& "dev$null")
   imdelete ("dummytempl.fits",ver-, >& "dev$null")
   imcopy (imnoise,"randomshift.fits",ver-)
   imcopy (imnoise,"dummytempl.fits",ver-)
   imcopy (imnoise//"[1:"//xn-d1//",1:"//yn//"]","dummytempl.fits["//d1+1//":"//xn//",1:"//yn//"]",ver-)
   xc1 = xn-d1+1
   imcopy (imnoise//"["//xc1//":"//xn//",1:"//yn//"]","dummytempl.fits[1:"//d1//",1:"//yn//"]",ver-)
   imcopy ("dummytempl.fits[1:"//xn//",1:"//yn-d2//"]","randomshift.fits[1:"//xn//","//d2+1//":"//yn//"]",ver-)
   imcopy ("dummytempl.fits[1:"//xn//","//yn-d2+1//":"//yn//"]","randomshift.fits[1:"//xn//",1:"//d2//"]",ver-)
      

   #estbacknoise.shの実行#
   sh estbacknoise.sh

   wc dataphot1 | scan(mu)   #estbacknoise.shの累積出力数をmuとする#
   printf ("cycle No.%d   total number = %d\n",nu,mu)
  }

#出力データdataphoto1(中はskyのカウント)からskyの平均値と標準偏差を求める#
wc dataphot1 | scan(n)
imdelete ("dataphot1.fits",ver-, >& "dev$null")
rtextimage("dataphot1","dataphot1.fits",oty="real",hea-,pix+,nsk=0,dim=n)

imstat ("dataphot1.fits",fie="mean,stddev",upp=INDEF,low=INDEF,ncl=10,usig=4,lsig=4,for-) | scan (c1,c2)

###########################
#分散(1σ)から限界等級推定#
###########################
limit_mag=-2.5*log(sigma*c2)/log(10)+zero

printf ("# Name  aperture(pix)  aperture('')  stddev(ADU)  mean(ADU)  %d sigma limit(mag)\n", sigma, >> output)
printf ("%s %8.3f %8.3f   %8f %8f  %6f\n",imobj,aper,c3,c2,c1,limit_mag, >> output)  #最終的に「Name,aperture(pixel),aperture(arcsec),stddev,mean,limit_mag」がアウトプットファイルに入る#

###############################
#Make count histgram for check#
###############################
min_hist=c1-c2*5
max_hist=c1+c2*5
bin_hist=c2/10.0

# Figure out #
phist ("dataphot1",z1=min_hist,z2=max_hist,binwidth=bin_hist,nbins=512,autoscale=yes,top_closed=no,hist_type="normal",listout=no,title="imtitle",xlabel="ADU",ylabel="Number",wx1=INDEF,wx2=INDEF,wy1=0.,wy2=INDEF,logx=no,logy=no,round=no,plot_type="line",box=yes,ticklabels=yes,majrx=5,minrx=5,majry=5,minry=5,fill=yes,vx1=0.,vx2=1.,vy1=0.,vy2=1.,append=no,pattern="solid",device="stdgraph")
# Print out #
phist ("dataphot1",z1=min_hist,z2=max_hist,binwidth=bin_hist,nbins=512,autoscale=yes,top_closed=no,hist_type="normal",listout=yes,title="imtitle",xlabel="ADU",ylabel="Number",wx1=INDEF,wx2=INDEF,wy1=0.,wy2=INDEF,logx=no,logy=no,round=no,plot_type="line",box=yes,ticklabels=yes,majrx=5,minrx=5,majry=5,minry=5,fill=yes,vx1=0.,vx2=1.,vy1=0.,vy2=1.,append=no,pattern="solid",device="stdgraph", > check_head//".hist")

# Gnuplot #
plot_height=(5/4.0)*bin_hist*n*1.0/sqrt(2*3.14159265358979*(c2**2))
print ("Push the Enter key, and finish this program.")

delete ("mkfig.sh",ver-, >& "dev$null")
print ("#!/bin/sh", > "mkfig.sh")
print ("gnuplot -e """, >> "mkfig.sh")
print ("set term x11 ;", >> "mkfig.sh")
print ("set size 0.6 ;", >> "mkfig.sh")
print ("set size ratio 1 ;", >> "mkfig.sh")
print ("set grid ;", >> "mkfig.sh")
print ("set xlabel 'Count' ;", >> "mkfig.sh")
print ("set xrange ["//min_hist//":"//max_hist//"] ;", >> "mkfig.sh")
print ("set ylabel 'Number' ;", >> "mkfig.sh")
print ("set yrange [0:"//plot_height//"] ;", >> "mkfig.sh")
print ("plot '"//check_head//".hist' u 1:2 w histep lt 1 lc 1 lw 2 t '"//n//" iterations', "//bin_hist//"*"//n//"*exp(-((x-"//c1//")**2)/(2*("//c2//"**2)))/sqrt(2*pi*("//c2//"**2)) lt 1 lc 0 t '{/=11 mean="//c1//",sigma="//c2//"}' ;", >> "mkfig.sh")
print ("set terminal postscript eps enhanced color ;", >> "mkfig.sh")
print ("set output '"//check_head//".eps' ;", >> "mkfig.sh")
print ("replot ;", >> "mkfig.sh")
print ("set terminal x11 ;", >> "mkfig.sh")
print ("pause -1", >> "mkfig.sh")
print ("""", >> "mkfig.sh")

sh mkfig.sh


#いらないものの消去#
!rm dataphot1
!rm dataphot2
!rm dataphot3
!rm dataphot1.fits
!rm dummytempl.fits
!rm randomshift.fits
!rm estbackerr.param
!rm estbacknoise.sh
!rm test_bkgerr.cat
!rm mkfig.sh

printf ("All finished\n")
