#天体画像の天体部分をノイズでうめた擬似ノイズ画像をつくるスクリプト。使用する際は必ずstsdasパッケージに入っておくこと#
#出力はノイズ画像#

    string *list1
    string inimage, outimage, maskimage, fn1,fn2,err1
    real pv1,pv2,pv3,pv4,pv5,pv6,npix1,npix2,sigma
    int n,m,xn,yn,d1,d2,xc1,nit

##########書き換えるのはココだけ########################################################    
    inimage="limitmag45m-B90s_good.fits" #画像の元となる画像#
    outimage="noise_45m-B90s_good.fits"      #出力するノイズ画像名#
    maskimage="check45m-B90s_good.fits"       #maskイメージ。あらかじめ作っておく#
    nit=10       #ループ数。画像内に天体がたくさん写っている場合大きくした方がいいかも#
#####################################################################################


    hselect(inimage,"NAXIS1","yes")| scan(npix1)  #画像のサイズ(x)をnpix1として読み込み#
    hselect(inimage,"NAXIS2","yes")| scan(npix2)  #画像のサイズ(y)をnpix2として読み込み#
    hselect(maskimage,"NAXIS1","yes")| scan(pv1)  #mask画像のサイズ(x)#
    hselect(maskimage,"NAXIS2","yes")| scan(pv2)  #mask画像のサイズ(y)#
    err1 = "myerrmask.pl"      #中身はmaskimageと同じ#
    if (pv1 != npix1 || pv2 != npix2)   #エラー文表示1#
       print ("Object Frame and Mask Frame have different format! ("//inimage//" & "//maskimage//")")
    else if (access(outimage))   #エラー文表示2#
       print ("Output Image File is already exist! ("//outimage//")")

##本番作業##
    else
      {
       delete (err1,ver-, >& "dev$null")
       imcopy (maskimage,err1,ver-)
       imdelete ("mysurim.fits",ver-, >& "dev$null")
       imcopy (inimage,outimage,ver-)
       imcopy (inimage,"mysurim.fits",ver-)
       imfill ("mysurim.fits",err1,"mask .ne. 0",-500000)  #天体部分(maskimageで0でない所)を-500000にmask#
       imfill (outimage,err1,"mask .ne. 0",0)  #outimage=inimageの天体部分を0にmask.最後にこの0の天体部分に天体部分だけノイズで他0の画像testbaho.fitsを足す#
       imstatistics ("mysurim.fits",fie="midpt",nc=5,us=3,ls=3,low=-100000,for-) | scan (pv6)   #-50000にmaskした天体画像に対して-500000の影響除いてmedianとる#
       d1=0
       d2=0
       n=0
       xn = int(npix1)
       yn = int(npix2)
       delete ("rashibaholist",ver-, >& "dev$null")
       while (n < nit)
        {
	 n=n+1
         urand (1,2,see=INDEF,sca=1.0) | scan (pv1,pv2)  #0~1の乱数生成#
         d1 = int(npix1*(0.15+pv1*0.7))  #x,yのシフト量としてランダムにかつ0.15*サイズ～1.85*サイズになるように#
         d2 = int(npix2*(0.15+pv2*0.7))
         imdelete ("ramshi_baho"//n//".fits",ver-, >& "dev$null")
         imdelete ("testbaho.fits",ver-, >& "dev$null")
         imcopy ("mysurim.fits","ramshi_baho"//n//".fits",ver-)
         imcopy ("mysurim.fits","testbaho.fits",ver-)
         print (n,d1,d2)
         
         ##maskがけ(-500000)された天体画像mysurim.fitsの左側と右側を入れ替えた画像testbaho.fitsをつくる##
         imcopy ("mysurim.fits[1:"//xn-d1//",1:"//yn//"]","testbaho["//d1+1//":"//xn//",1:"//yn//"]",ver-)
         xc1 = xn-d1+1
         imcopy ("mysurim.fits["//xc1//":"//xn//",1:"//yn//"]","testbaho.fits[1:"//d1//",1:"//yn//"]",ver-)
         ##testbaho.fitsの上側と下側を入れ替えた画像ramshi_baho?.fitsをつくる##
         imcopy ("testbaho.fits[1:"//xn//",1:"//yn-d2//"]","ramshi_baho"//n//".fits[1:"//xn//","//d2+1//":"//yn//"]",ver-)
         imcopy ("testbaho.fits[1:"//xn//","//yn-d2+1//":"//yn//"]","ramshi_baho"//n//".fits[1:"//xn//",1:"//d2//"]",ver-)
         print ("ramshi_baho"//n//".fits", >> "rashibaholist")
        }
      imdelete ("testbaho.fits",ver-, >& "dev$null")
      if (nit > 1)
        {
         if (nit < 10)
            pv5=2.5
         else
            pv5=3
         imstatistics (inimage,fie="midpt,stddev",low=INDEF,upp=INDEF,lsig=5,usig=5,ncl=10,for-,bin=0.1) | scan (pv3,pv4)
         imdelete ("expbaho.pl",ver-, >& "dev$null")
         imdelete ("sqrtexpbaho.fits",ver-, >& "dev$null")
      #上でランダムシフトさせた画像10枚をスタック。clipped meanをとるが、その際のlthresholdとhthresholdは天体画像の平均値から10σ.更にexpmapとして足し合わせに寄与した画像数(expname="")のmap：expbaho.plを吐き出すようにした。使う画像は天体部分が-500000になっているのでそこの部分は寄与しない。#
         imcombine ("@rashibaholist","testbaho.fits",sigma="",expm="expbaho.pl",comb="average",reje="sigclip",scale="none",weig="none",expname="",blank=0,lth=pv3-10*pv4,hth=pv3+10*pv4,mcli+,nkee=0,lsig=pv5,hsig=pv5) 
         pv5=sqrt(real(nit))
         imstatistics ("expbaho.pl",fie="max",ncl=0,low=INDEF,upp=INDEF,for-,bin=0.1) | scan (pv2)
         pv3=real(nit)/pv2   #いらないように見えるが・・・？#
	 pv3=1.0
         imdelete ("expbaho.fits",ver-, >& "dev$null")
         imarith ("expbaho.pl","*",pv3,"expbaho.fits",ver-)  #単にexpbaho.plの拡張子をfitsにしただけで中身変わらない#
         print (pv5,pv2)  #pv5:(ループ数)^0.5,pv2:#
         imcalc ("expbaho.fits","sqrtexpbaho.fits","sqrt(im1)",ver-)
         imarith ("testbaho.fits","*","sqrtexpbaho.fits","testbaho.fits",ver-)  #足し合わせた分良くなったS/Nを1枚分にまで戻す((足し合わせに寄与した枚数)^0.5かける)#
        }
      else
         imcopy ("ramshi_baho1.fits","testbaho.fits",ver-)
      imstatistics ("testbaho.fits",fie="midpt",low=INDEF,upp=INDEF,lsig=5,usig=5,ncl=10,for-,bin=0.1) | scan (pv4)
      pv5=pv6-pv4   #pv6(ランダムシフトする前のmysurim.fitsの天体部分の寄与除いたmedian)とpv4(ランダムシフト,足し合わせした後の画像のmedian)の差。ランダムシフト画像はいろいろ操作したので若干元とズレている場合あり、その補正項#
      #print (pv6,pv4,pv5)
      imarith ("testbaho.fits","+",pv5,"testbaho.fits",ver-)  #念のため天体画像の天体除いた部分とmedianレベルを合わせておく#
      imfill ("testbaho.fits",err1,"mask .eq. 0",0)   #元画像(inimage)でbackgroundになってる部分についてノイズ画像を0にmaskがけする。#
   ##天体部分のみ0の画像(outimage)と天体部分以外0で天体部分だけノイズで埋まった画像(testbaho.fits)を足す##
      imarith (outimage,"+","testbaho.fits",outimage,ver-)
     
     ##いらないファイルの消去##
      imdelete ("@rashibaholist",ver-, >& "dev$null")
      imdelete ("testbaho.fits",ver-, >& "dev$null")
      imdelete ("mysurfit.fits",ver-, >& "dev$null")
      imdelete ("mysurim.fits",ver-, >& "dev$null")
      imdelete ("myerrmask.pl",ver-, >& "dev$null")
      imdelete ("sqrtexpbaho.fits",ver-, >& "dev$null")
      imdelete ("expbaho.fits",ver-, >& "dev$null")
      imdelete ("expbaho.pl",ver-, >& "dev$null")
      delete ("rashibaholist",ver-, >& "dev$null")
     }
    list1 = ""
  
   

