#!/bin/sh

#複数画像にSExtractorかけるshスクリプト.検出後のカタログ作りの部分は相当の任意性あり.出力はdetect-"ID".catという天体カタログ#

###書き換えるのはココだけ##############################################
#※適当でいいのでSExtractorのパラメータファイルとそれに応じた,~.conv,~.nmwを同じディレクトリ内に先に用意しておくこと。
SExt_file="detect.sex"  

ID_first=12
ID_last=8
#天体検出かける画像を特徴づけるIDの始まりの文字数(ID_first)とそこから終わりまでの文字数(ID_last)#
#例えば、subskySA104B30s-006.fitsというような画像でIDを"B30s-006"と考えると画像名の12文字目から8文字なので、ID_first=12,ID_last=8#

#SExtractorのパラメータ設定#
minarea=20   #DETECT_MINAREA#
threshold=5  #DETECT_THRESH#
aperture=20  #pixel単位で測光aperture指定#
#出力parameterリストobj-detection.paramの作成。出力させたいparameterを自由に設定#
if [ -e obj-detection.param ]; then
  rm obj-detection.param
fi
echo "NUMBER" > obj-detection.param
echo "X_IMAGE" >> obj-detection.param
echo "Y_IMAGE" >> obj-detection.param
echo "FLUX_APER(1)" >> obj-detection.param
echo "FLUX_AUTO" >> obj-detection.param
echo "BACKGROUND" >> obj-detection.param
echo "FLAGS" >> obj-detection.param

#天体カタログの位置しばり、明るさしばりの設定(必要なければ全部defaultにしとくこと)#
x_min=350    #(0)#
x_max=2800   #(3056)#
y_min=100    #(0)#
y_max=2920   #(3056)#

luminous1=1   #明るい方の"luminous1"番目から(1)#
luminous2=30  #"luminous2"番目までを選んでくる(10000)#
###書き換えるのココまで##################################################




luminous3=`expr ${luminous2} - ${luminous1} + 1`  

BUFIFS=$IFS
IFS=

exec 3< $1       #かませるファイルの何列目を使うかの指定#
while read FL 0<&3 #FLとして認識される=>ループ#
do
    #入力ファイルの一部をindexとして記憶=>IDindexに格納#
       IDindex=`echo $FL | awk '{print substr($1,'${ID_first}','${ID_last}')}'`

      sex $FL -CATALOG_NAME test.cat -PARAMETERS_NAME obj-detection.param -DETECT_MINAREA ${minarea} -DETECT_THRESH ${threshold} -PHOT_APERTURES ${aperture} -c ${SExt_file}
      awk '$1>0 && $7<5 && $2>'${x_min}' && $2<'${x_max}' && $3>'${y_min}' && $3<'${y_max}'{print}' test.cat | sort -n -k 4 -r | head -${luminous2} | tail -${luminous3} > detect-${IDindex}.cat

      echo "${IDindex} is finished!"
done
exec 3<&-

IFS=$BUFIFS

rm obj-detection.param
rm test.cat

