#画像の位置合わせ作業を行う。具体的には(1)天体カタログから同一天体マッチング(xyxymatch)#
#(1')画像のフォーマット広げる#
#(2)画像の変換規則作り(geomap)(3)実際に画像変換#
#をいっぺんに行う。ただし一番こけやすい(1)でこけた場合はそこで終わる。#

#出力は(1)フォーマット拡張までした天体マッチングカタログ(formatch-***)とそのリスト(formatchcat.lis)、画像毎のマッチ数のデータファイル(matchedOBJnumber.dat)、(2)変換規則のデータベース(geomap_result.db)、(3)位置合わせされた画像#
######################################################################

string *list1,*list2,*list3,*list4
string inputimage_lis,inputimagefits,inputcat_lis,refcat,outputimage_lis
string fn1,fn2,fn3,fn4
real   a,b,c
int    xcol,ycol,deltax,deltay,ddeltax,ddeltay,min_match,A,B,npix1,npix2,adpix1,adpix2
##############書き換えるのはココだけ###############################################################
#ただしxyxymatchはこけやすいのでそこのパラメータは適時いじるべし##################################
inputimage_lis="subskySA104B-all-.lis"   #位置合わせ前の画像リスト#
inputimagefits="subskySA104B30s-006.fits"  #位置合わせ前の画像を適当に1枚。フォーマット調べる用#
inputcat_lis="detect-SA104B-.lis"      #天体カタログが入ったリスト#
xcol=2                              #天体カタログの何列目にxが書かれているか#
ycol=3                              #天体カタログの何列目にyが書かれているか#
refcat="detect-B30s-007.cat"   #xyxymatchのリファレンスとなるカタログ名#
deltax=200                     #フォーマット拡張でx方向に増やしたいピクセル数#
deltay=100                     #フォーマット拡張でy方向に増やしたいピクセル数#
min_match=10                   #天体マッチ数の最小値。これより少ない天体数しかマッチしなかったら(1)で中止する#
outputimage_lis="shiftSA104B-all-.lis"     #出来上がりの画像リスト名.事前に用意しとく。# 
##############書き換えここまで###################################################################
list1=inputimage_lis
list2=inputcat_lis
list3=outputimage_lis

#リスト作成loop#
while (fscan (list1, fn1) != EOF) #list1=インプットリストの上から１flame毎ループさせる。今考えてる？番目のfitsファイルをfn1として認識#
  {
    print (fn1, >> "hoge_inputimage.lis")
  }
while (fscan (list3, fn3) != EOF) 
  {
    print (fn3, >> "hoge_outputimage.lis")
   }



##(1)xyxymatch&フォーマット拡張##
B=-10

delete ("matchedOBJnumber.dat",ver-, >& "dev$null")
delete ("formatchcat.lis",ver-, >& "dev$null")
while (fscan (list2, fn2) != EOF) 
  {
      delete ("hogematch.cat",ver-, >& "dev$null")
      delete ("hogematch+.cat",ver-, >& "dev$null")
      xyxymatch (fn2, refcat, "hogematch.cat", 3., refpoints="", xin=INDEF, yin=INDEF, xmag=INDEF, ymag=INDEF, xrotation=INDEF, yrotation=INDEF, xref=INDEF, yref=INDEF, xcolumn=xcol, ycolumn=ycol, xrcolumn=xcol, yrcolumn=ycol, separation=9., matching="triangles", nmatch=50, ratio=10., nreject=30, xformat="%13.3f", yformat="%13.3f", interactive=no, verbose=yes, icommands="")

      #マッチカタログの名前変更＆フォーマット拡張を行うshスクリプトformatch.shの作成#
      ddeltax=deltax/2
      ddeltay=deltay/2
      delete ("formatch.sh",ver-, >& "dev$null")
      print ("#!/bin/sh", > "formatch.sh")
      print ("awk '$1>0{print $1+"//ddeltax//",$2+"//ddeltay//",$3,$4}' hogematch.cat > formatch-"//fn2//"", >> "formatch.sh")
      print ("awk '$1>0{print $1+"//ddeltax//",$2+"//ddeltay//",$3,$4}' hogematch.cat > hogematch+.cat", >> "formatch.sh")  
      print ("wc formatch-"//fn2//" >> matchedOBJnumber.dat", >> "formatch.sh")

      #formatch.shの実効#
      sh formatch.sh

      wc hogematch+.cat | scan(A)
      if (A < min_match)
        print (A) | scan(B)

      #リスト化#
      print ("formatch-"//fn2//"", >> "formatchcat.lis")
  }
##※非常にこけやすいタスクなので、こけたらカタログ作りをやり直すか、パラメータ(nmatchやnreject)をいじるなどしてtry&error!!##

##(1)で上手く全画像でxyxymatchが上手くいってるようならば先に進み、上手くいってない画像が一枚でもあればプログラム終了##
if (B > -1)
   print ("xyxymatch is failed!(Matched number is too small.) Program is stopped before geomap.")
else {
   print ("xyxymatch is good. Let's go to geomap and geotran.")
      

      ##(2)geomap##
      hselect (inputimagefits,"NAXIS1,NAXIS2",exp+) | scan (npix1,npix2)
      adpix1=npix1+deltax
      adpix2=npix2+deltay     #最終画像のフォーマットの設定#

      delete ("geomap_result.db",ver-, >& "dev$null")
      geomap ("@formatchcat.lis", "geomap_result.db", 1., adpix1, 1., adpix2, transforms="", results="", fitgeometry="general", function="polynomial", xxorder=2, xyorder=2, xxterms="half", yxorder=2, yyorder=2, yxterms="half", maxiter=50, reject=3., calctype="real", verbose=yes, interactive=no, graphics="stdgraph", cursor="")


      ##(3)geotran##
      geotran ("@hoge_inputimage.lis", "@hoge_outputimage.lis", "geomap_result.db", "@formatchcat.lis", geometry="geometric", xin=INDEF, yin=INDEF, xshift=INDEF, yshift=INDEF, xout=INDEF, yout=INDEF, xmag=INDEF, ymag=INDEF, xrotation=INDEF, yrotation=INDEF, xmin=INDEF, xmax=INDEF, ymin=INDEF, ymax=INDEF, xscale=1., yscale=1., ncols=adpix1, nlines=adpix2, xsample=1., ysample=1., interpolant="linear", boundary="constant", constant=-1000000., fluxconserve=yes, nxblock=512, nyblock=512, verbose=yes)

     }



#いらないものの削除#
!rm hoge_inputimage.lis
!rm hoge_outputimage.lis
!rm hogematch.cat
!rm hogematch+.cat

list1=""
list2=""
list3=""
list4=""

