#バックグラウンドのノイズゆらぎを測定するスクリプト。「仮想sky画像に対して測光」をランダムに行う。"sex　天体画像　ランダムシフトさせた仮想sky　-c　~.sex"を多数回行い一回毎に得られるskyの情報(mean.stddev)を多数回平均#
#出力はバックグラウンドゆらぎが格納されたファイル。中身は「aperture(pixel),aperture(arcsec),skyのstddev,skyのmean」なので３列目が1σ相当。#

string *list1
string imobj,imnoise,fsext,output
real   aperture,pscale,minarea,threshold,c1,c2,c3,zero,limit_mag
int    nu,mu,n,m,nit,sigma
int    npix1,npix2,xn,yn,xc1,yc1,d1,d2

########書き換えるのはココだけ########################################################################NEOnoise_finM51V60s.fits
imobj = "finM51V60s.fits"  #天体画像#
imnoise = "NEOnoise_finM51V60s.fits"  #仮想sky画像#
fsext = "default.sex"      #出力ファイルやparamファイル,Apertureがどうであれあとで全部指定されるのでココに入るパラメータファイルはなんでもいい#
output = "bkgnoise_finM51V60s.txt"  #最終的に欲しいskyの平均カウントとそこからの標準偏差σ_skyの入るファイル名#
sigma=5  #何σ限界を求めたいか?#
zero=25.2 #画像のゼロ点(１秒あたりでなく積分時間あたり)#

#SExtractorのパラメータ設定#
aperture=20  #apertureの設定#
pscale=1.38 #1pixelを見込む角度(arcsec)#
minarea=10 #DETECT_MINAREA#
threshold=5 #DETECT_THRESHOLD#
nit = 10000  #合計何点skyのデータをとるか？#
#########書き換えるのココまで#########################################################################


hselect (imobj,"NAXIS1,NAXIS2",exp+) | scan (npix1,npix2)  #imobjのフォーマット[?:?]がnpix1とnpix2にscanされる#
xn = int(npix1)
yn = int(npix2)

c3 = aperture*pscale  #apertureの角度スケール#

   #出力parameterリストestbackerr.paramの作成#
delete ("estbackerr.param",ver-, >& "dev$null")
print ("X_IMAGE", >> "estbackerr.param")
print ("Y_IMAGE", >> "estbackerr.param")
print ("FLUX_APER(1)", >> "estbackerr.param")  

#SExtractorをかけるshスクリプトestbacknoise.shの作成#
delete ("estbacknoise.sh",ver-, >& "dev$null")
print ("#!/bin/sh", > "estbacknoise.sh")
print ("sex "//imobj//" randomshift.fits -CATALOG_NAME test_bkgerr.cat -DETECT_MINAREA "//minarea//" -DETECT_THRESH "//threshold//" -PHOT_APERTURES "//aperture//" -PARAMETERS_NAME estbackerr.param -MAG_ZEROPOINT "//zero//" -PIXEL_SCALE "//pscale//" -CHECKIMAGE_TYPE NONE -VERBOSE_TYPE quiet -c "//fsext, >> "estbacknoise.sh")  #上で何をパラメータファイルにしようと、ここでestbackerr.paramとtest_bkgerr.catが指定される#
print ("awk '$1>=1 && $1<=1000000 && $2>=1 && $2<=1000000 {print $3}' test_bkgerr.cat >> dataphot1", >> "estbacknoise.sh")  #SExtractor結果のうちFLUX_APER(1)をdataphoto1というリストに書き込んでいく#

#途中経過の表示#
printf ("measure sky fluctuation on %s at %5.3f arcsec diameter\n",imnoise,c3)
printf ("total %d random apertures are used\n",nit)

#ランダムシフトさせた仮想sky画像=randomshift.fitsの作成+estbacknoise.shの実行#
nu=0  #nuは画像に対してestbacknoise.shをかける回数#
mu=0  #muは検出されたskyデータの数=nu*(1枚の画像から得られるデータ数)#
delete ("dataphot1",ver-, >& "dev$null")
while (mu < nit) #mu<nitの間ループ#
  { 
   nu=nu+1
     #randomshift.fitsの作成#
   urand (1,2,see=INDEF,sca=1) | scan (c1,c2)
   d1 = int(npix1*(0.15+0.7*c1))
   d2 = int(npix2*(0.15+0.7*c2))
   imdelete ("randomshift.fits",ver-, >& "dev$null")
   imdelete ("dummytempl.fits",ver-, >& "dev$null")
   imcopy (imnoise,"randomshift.fits",ver-)
   imcopy (imnoise,"dummytempl.fits",ver-)
   imcopy (imnoise//"[1:"//xn-d1//",1:"//yn//"]","dummytempl.fits["//d1+1//":"//xn//",1:"//yn//"]",ver-)
   xc1 = xn-d1+1
   imcopy (imnoise//"["//xc1//":"//xn//",1:"//yn//"]","dummytempl.fits[1:"//d1//",1:"//yn//"]",ver-)
   imcopy ("dummytempl.fits[1:"//xn//",1:"//yn-d2//"]","randomshift.fits[1:"//xn//","//d2+1//":"//yn//"]",ver-)
   imcopy ("dummytempl.fits[1:"//xn//","//yn-d2+1//":"//yn//"]","randomshift.fits[1:"//xn//",1:"//d2//"]",ver-)
      

   #estbacknoise.shの実行#
   sh estbacknoise.sh

   wc dataphot1 | scan(mu)   #estbacknoise.shの累積出力数をmuとする#
   printf ("cycle No.%d   total number = %d\n",nu,mu)
  }

#出力データdataphoto1(中はskyのカウント)からskyの平均値と標準偏差を求める#
wc dataphot1 | scan(n)
imdelete ("dataphot1.fits",ver-, >& "dev$null")
rtextimage("dataphot1","dataphot1.fits",oty="real",hea-,pix+,nsk=0,dim=n)

imstat ("dataphot1.fits",fie="mean,stddev",upp=INDEF,low=INDEF,ncl=10,usig=4,lsig=4,for-) | scan (c1,c2)

#分散(1σ)から限界等級推定#
limit_mag=-2.5*log(sigma*c2)/log(10)+zero

printf ("aperture(pix)  aperture('')  stddev  mean  %d sigma limit\n", sigma, >> output)
printf ("%8.5f %7.3f   %8f %8f %6f\n",aper,c3,c2,c1,limit_mag, >> output)  #最終的に「aperture(pixel),aperture(arcsec),stddev,mean,limit_mag」がアウトプットファイルに入る#


#いらないものの消去#
!rm dataphot1
imdelete ("dataphot1.fits",ver-, >& "dev$null")
imdelete ("dummytempl.fits",ver-, >& "dev$null")
imdelete ("randomshift.fits",ver-, >& "dev$null")
!rm estbackerr.param
!rm estbacknoise.sh
!rm test_bkgerr.cat
